# ChunkCodecLibBrotli

This package implements the ChunkCodec interface for the following encoders and decoders
using the brotli C library <https://brotli.org/>

1. `BrotliCodec`, `BrotliEncodeOptions`, `BrotliDecodeOptions`

## Example

```julia-repl
julia> using ChunkCodecLibBrotli

julia> data = [0x00, 0x01, 0x02, 0x03];

julia> compressed_data = encode(BrotliEncodeOptions(;quality=6), data);

julia> decompressed_data = decode(BrotliCodec(), compressed_data; max_size=length(data), size_hint=length(data));

julia> data == decompressed_data
true
```

The low level interface is defined in the `ChunkCodecCore` package.

using Random: Random
using ChunkCodecCore: encode_bound, decoded_size_range, encode, decode
using ChunkCodecLibBrotli:
    ChunkCodecLibBrotli,
    BrotliCodec,
    BrotliEncodeOptions,
    BrotliDecodeOptions,
    BrotliDecodingError
using ChunkCodecTests: test_codec
using Test: @testset, @test_throws, @test
using Aqua: Aqua

Aqua.test_all(ChunkCodecLibBrotli; persistent_tasks = false)

Random.seed!(1234)

@testset "encode_bound" begin
    local a = last(decoded_size_range(BrotliEncodeOptions()))
    @test encode_bound(BrotliEncodeOptions(), a) == typemax(Int64) - 1
end
@testset "default" begin
    test_codec(BrotliCodec(), BrotliEncodeOptions(), BrotliDecodeOptions(); trials=5)
end
@testset "options" begin
    # quality should get clamped to 0 to 11
    @test BrotliEncodeOptions(; quality=-10).quality == 0
    @test BrotliEncodeOptions(; quality=12).quality == 11
    @test BrotliEncodeOptions(; quality=-1).quality == 0
    # Test invalid lgwin
    @test_throws ArgumentError BrotliEncodeOptions(; lgwin=9)
    @test_throws ArgumentError BrotliEncodeOptions(; lgwin=25)
    # Test invalid mode values
    @test_throws ArgumentError BrotliEncodeOptions(; mode=-1)
    @test_throws ArgumentError BrotliEncodeOptions(; mode=3)

    for quality in 0:11
        test_codec(BrotliCodec(), BrotliEncodeOptions(; quality), BrotliDecodeOptions(); trials=5)
    end

    # Test encoding/decoding with options
    # quality below 2 and lgwin below 14 seems to trigger the fallback compression
    for mode in [0, 1, 2]
        for quality in [0, 1, 2]
            for lgwin in [10, 20, 24]
                test_codec(BrotliCodec(), BrotliEncodeOptions(; quality, lgwin, mode), BrotliDecodeOptions(); trials=5)
            end
        end
    end
end
@testset "unexpected eof" begin
    local d = BrotliDecodeOptions()
    local u = [0x00, 0x01, 0x02]
    local c = encode(BrotliEncodeOptions(), u)
    @test decode(d, c) == u
    for i in 1:length(c)
        @test_throws BrotliDecodingError("unexpected end of stream") decode(d, c[1:i-1])
    end
end
@testset "Brotli doesn't support concatenation" begin
    e = BrotliEncodeOptions()
    d = BrotliDecodeOptions()
    u = [0x00, 0x01, 0x02]
    c = encode(e, u)
    @test decode(d, c) == u
    @test_throws BrotliDecodingError decode(d, u)
    c[begin] ⊻= 0xFF
    @test_throws BrotliDecodingError decode(d, c)
    @test_throws BrotliDecodingError("unexpected $(length(c)) bytes after stream") decode(d, [encode(e, u); c])
    @test_throws BrotliDecodingError("unexpected $(length(c)) bytes after stream") decode(d, [encode(e, u); encode(e, u)])
    @test_throws BrotliDecodingError("unexpected 1 bytes after stream") decode(d, [encode(e, u); 0x00])
end
@testset "errors" begin
    @test sprint(Base.showerror, BrotliDecodingError("test error message")) ==
        "BrotliDecodingError: test error message"
end
@testset "unit tests for unsafe_MakeUncompressedStream" begin
    for n in [0:200000; 2^20-2:2^20+2; 2^24-1:2^24+1]
        src = rand(UInt8, n)
        dst = zeros(UInt8, encode_bound(BrotliEncodeOptions(), Int64(n)))
        cconv_src = Base.cconvert(Ptr{UInt8}, src)
        cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
        enc_size = GC.@preserve cconv_src cconv_dst let
            src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
            dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
            ChunkCodecLibBrotli.unsafe_MakeUncompressedStream(src_p, Int64(n), dst_p)
        end
        @test enc_size ≤ length(dst)
        resize!(dst, enc_size)
        @test decode(BrotliCodec(), dst; size_hint=n) == src
    end
end

# This file contains tests that require a large amount of memory (at least 24 GB)
# and take a long time to run. The tests are designed to check the 
# compression and decompression functionality of the ChunkCodecLibBrotli package 
# with very large inputs. These tests are not run with CI

using ChunkCodecLibBrotli:
    ChunkCodecLibBrotli,
    BrotliCodec,
    BrotliEncodeOptions,
    encode,
    decode
using Test: @testset, @test

@testset "Big Memory Tests" begin
    Sys.WORD_SIZE == 64 || error("tests require 64 bit word size")
    @info "compressing zeros"
    for n in (2^32 - 1, 2^32, 2^32 +1, 2^33)
        @info "compressing"
        local c = encode(BrotliEncodeOptions(;quality=9), zeros(UInt8, n))
        @info "decompressing"
        local u = decode(BrotliCodec(), c; size_hint=n)
        c = nothing
        all_zero = all(iszero, u)
        len_n = length(u) == n
        @test all_zero && len_n
    end

    @info "compressing random"
    for n in (2^32 - 1, 2^32, 2^32 +1)
        local u = rand(UInt8, n)
        @info "compressing"
        local c = encode(BrotliEncodeOptions(;quality=9), u)
        @info "decompressing"
        local u2 = decode(BrotliCodec(), c; size_hint=n)
        c = nothing
        are_equal = u == u2
        @test are_equal
    end
end

module ChunkCodecLibBrotli

using brotli_jll: libbrotlidec, libbrotlienc

using ChunkCodecCore:
    Codec,
    EncodeOptions,
    DecodeOptions,
    check_contiguous,
    check_in_range,
    grow_dst!,
    DecodingError,
    MaybeSize,
    NOT_SIZE
import ChunkCodecCore:
    decode_options,
    try_decode!,
    try_resize_decode!,
    try_encode!,
    encode_bound,
    is_thread_safe,
    try_find_decoded_size,
    decoded_size_range

export BrotliCodec,
    BrotliEncodeOptions,
    BrotliDecodeOptions,
    BrotliDecodingError

# reexport ChunkCodecCore
using ChunkCodecCore: ChunkCodecCore, encode, decode
export ChunkCodecCore, encode, decode


include("libbrotli.jl")

"""
    struct BrotliCodec <: Codec
    BrotliCodec()

brotli compression using the brotli C library <https://brotli.org/>

This is the brotli (.br) format described in RFC 7932

See also [`BrotliEncodeOptions`](@ref) and [`BrotliDecodeOptions`](@ref)
"""
struct BrotliCodec <: Codec
end
decode_options(::BrotliCodec) = BrotliDecodeOptions()

include("encode.jl")
include("decode.jl")

end # module ChunkCodecLibBrotli

# Constants and c wrapper functions ported to Julia from https://github.com/google/brotli/blob/v1.1.0/c

const BROTLI_MIN_WINDOW_BITS = 10
const BROTLI_MAX_WINDOW_BITS = 24

const BROTLI_WINDOW_GAP = 16
BROTLI_MAX_BACKWARD_LIMIT(W) = (Int64(1) << W) - BROTLI_WINDOW_GAP

const BROTLI_MIN_QUALITY = 0
const BROTLI_MAX_QUALITY = 11

# Default compression mode.
const BROTLI_MODE_GENERIC = 0
# Compression mode for UTF-8 formatted text input.
const BROTLI_MODE_TEXT = 1
# Compression mode used in WOFF 2.0.
const BROTLI_MODE_FONT = 2

# Options that are used here.
@enum BrotliEncoderParameter::Cint begin
    BROTLI_PARAM_MODE = 0
    BROTLI_PARAM_QUALITY = 1
    BROTLI_PARAM_LGWIN = 2
    BROTLI_PARAM_SIZE_HINT = 5
end

const BROTLI_OPERATION_PROCESS = Cint(0)
const BROTLI_OPERATION_FLUSH = Cint(1)
const BROTLI_OPERATION_FINISH = Cint(2)
const BROTLI_OPERATION_EMIT_METADATA = Cint(3)

# Just used to mark the type of pointers
mutable struct BrotliEncoderState end
mutable struct BrotliDecoderState end

function unsafe_BrotliEncoderSetParameter(state::Ptr{BrotliEncoderState}, param::BrotliEncoderParameter, value::UInt32)::Nothing
    res = @ccall libbrotlienc.BrotliEncoderSetParameter(
        state::Ptr{BrotliEncoderState},
        Integer(param)::Cint,
        value::UInt32,
    )::Cint
    if res != 1
        error("setting parameter $(param) to $(value)")
    end
    nothing
end

# Helper function ported from https://github.com/google/brotli/blob/v1.1.0/c/enc/encode.c#L1215
# /* Wraps data to uncompressed brotli stream with minimal window size.
#    |output| should point at region with at least encode_bound
#    addressable bytes.
#    Returns the length of stream. */
function unsafe_MakeUncompressedStream(input::Ptr{UInt8}, input_size::Int64, output::Ptr{UInt8})::Int64
    size::Int64 = input_size
    result::Int64 = 0
    offset::Int64 = 0
    if iszero(input_size)
        unsafe_store!(output, 0x06)
        return 1
    end
    unsafe_store!(output + result, 0x21) # window bits = 10, is_last = false
    result += 1
    unsafe_store!(output + result, 0x03) # empty metadata, padding
    result += 1
    while size > 0
        local nibbles::UInt32 = 0
        local chunk_size::UInt32
        local bits::UInt32
        chunk_size = (size > (Int64(1) << 24)) ? (UInt32(1) << 24) : size%UInt32
        if chunk_size > (UInt32(1) << 16)
            nibbles = (chunk_size > (UInt32(1) << 20)) ? 2 : 1
        end
        bits = (nibbles << 1) | ((chunk_size - UInt32(1)) << 3) | (UInt32(1) << (19 + 4 * nibbles))
        unsafe_store!(output + result, bits%UInt8)
        result += 1
        unsafe_store!(output + result, (bits >> 8)%UInt8)
        result += 1
        unsafe_store!(output + result, (bits >> 16)%UInt8)
        result += 1
        if nibbles == 2
            unsafe_store!(output + result, (bits >> 24)%UInt8)
            result += 1
        end
        @static if VERSION ≥ v"1.10"
            Libc.memcpy(output + result, input + offset, chunk_size)
        else
            unsafe_copyto!(output + result, input + offset, chunk_size)
        end
        result += chunk_size
        offset += chunk_size
        size -= chunk_size
    end
    unsafe_store!(output + result, 0x03)
    result += 1
    return result
end

const BROTLI_DECODER_RESULT_ERROR = Cint(0)
const BROTLI_DECODER_RESULT_SUCCESS = Cint(1)
const BROTLI_DECODER_RESULT_NEEDS_MORE_INPUT = Cint(2)
const BROTLI_DECODER_RESULT_NEEDS_MORE_OUTPUT = Cint(3)

# Range of memory allocation error codes.
const RANGE_BROTLI_DECODER_ERROR_ALLOC = -30:-21

# The following is the original license info from https://github.com/google/brotli/blob/v1.1.0/LICENSE

#=
Copyright (c) 2009, 2010, 2013-2016 by the Brotli Authors.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
=#

"""
    struct BrotliEncodeOptions <: EncodeOptions
    BrotliEncodeOptions(; kwargs...)

brotli compression using the brotli C library <https://brotli.org/>

This is the brotli (.br) format described in RFC 7932

# Keyword Arguments

- `codec::BrotliCodec=BrotliCodec()`
- `quality::Integer=$(BROTLI_MAX_QUALITY)`: The quality must be between $(BROTLI_MIN_QUALITY) and $(BROTLI_MAX_QUALITY).

  $(BROTLI_MIN_QUALITY) gives best compression speed, $(BROTLI_MAX_QUALITY) gives best compressed size.
- `lgwin::Integer=$(BROTLI_MAX_WINDOW_BITS)`: Sliding LZ77 window size is at most `(1 << lgwin) - 16`.

  Must be between $(BROTLI_MIN_WINDOW_BITS) and $(BROTLI_MAX_WINDOW_BITS).
  Encoder may reduce this value, e.g. if input is much smaller than window size.
- `mode::Integer=0`: Tune encoder for specific input.

  0 is default.
  1 is for UTF-8 text.
  2 is for WOFF 2.0.
"""
struct BrotliEncodeOptions <: EncodeOptions
    codec::BrotliCodec
    quality::UInt32
    lgwin::UInt32
    mode::UInt32
end
function BrotliEncodeOptions(;
        codec::BrotliCodec=BrotliCodec(),
        quality::Integer=BROTLI_MAX_QUALITY,
        lgwin::Integer=BROTLI_MAX_WINDOW_BITS,
        mode::Integer=0,
        kwargs...
    )
    check_in_range(0:2; mode)
    check_in_range(BROTLI_MIN_WINDOW_BITS:BROTLI_MAX_WINDOW_BITS; lgwin)
    BrotliEncodeOptions(
        codec,
        UInt32(clamp(quality, BROTLI_MIN_QUALITY, BROTLI_MAX_QUALITY)),
        UInt32(lgwin),
        UInt32(mode),
    )
end

# https://github.com/google/brotli/issues/501
is_thread_safe(::BrotliEncodeOptions) = true

# Modified from the BrotliEncoderMaxCompressedSize function in
# https://github.com/google/brotli/blob/v1.1.0/c/enc/encode.c#L1202
# to use saturating Int64 instead of size_t
function encode_bound(::BrotliEncodeOptions, src_size::Int64)::Int64
    # [window bits / empty metadata] + N * [uncompressed] + [last empty]
    num_large_blocks = src_size >> 14
    overhead = 2 + (4 * num_large_blocks) + 3 + 1
    clamp(
        widen(src_size) +
        widen(overhead),
        Int64,
    )
end

function decoded_size_range(::BrotliEncodeOptions)
    # From ChunkCodecTests.find_max_decoded_size(::EncodeOptions)
    Int64(0):Int64(1):Int64(0x7ff8007ff8007ff4)
end

function try_encode!(e::BrotliEncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    check_in_range(decoded_size_range(e); src_size)
    # Unfortunately the builtin BrotliEncoderCompress C function doesn't report errors
    # in a nice way. So this is ported from BrotliEncoderCompress in
    # https://github.com/google/brotli/blob/v1.1.0/c/enc/encode.c#L1247
    # with different error handling logic.
    max_out_size = encode_bound(e, src_size) # the decoded_size_range check ensures no overflow issue here.
    clamped_dst_size = min(dst_size, max_out_size)
    if iszero(dst_size)
        # Output buffer needs at least one byte.
        return NOT_SIZE
    end
    cconv_src = Base.cconvert(Ptr{UInt8}, src)
    cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
    GC.@preserve cconv_src cconv_dst begin
        src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
        dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
        if iszero(src_size)
            # Handle the special case of empty input.
            unsafe_store!(dst_p, 0x06)
            return Int64(1)
        end
        s = @ccall libbrotlienc.BrotliEncoderCreateInstance(
            C_NULL::Ptr{Cvoid},
            C_NULL::Ptr{Cvoid},
            C_NULL::Ptr{Cvoid},
        )::Ptr{BrotliEncoderState}
        if s == C_NULL
            throw(OutOfMemoryError())
        end
        try
            unsafe_BrotliEncoderSetParameter(s, BROTLI_PARAM_QUALITY, e.quality)
            # https://github.com/google/brotli/blob/v1.1.0/c/tools/brotli.c#L1181
            # Decrease lgwin if src_size is small
            # At some point the C library may do this automatically
            lgwin = e.lgwin
            while BROTLI_MAX_BACKWARD_LIMIT(lgwin-1) ≥ src_size && lgwin > BROTLI_MIN_WINDOW_BITS
                lgwin -= UInt32(1)
            end
            @assert lgwin ≤ e.lgwin
            unsafe_BrotliEncoderSetParameter(s, BROTLI_PARAM_LGWIN, lgwin)
            unsafe_BrotliEncoderSetParameter(s, BROTLI_PARAM_MODE, e.mode)
            # https://github.com/google/brotli/blob/v1.1.0/c/tools/brotli.c#L1193
            unsafe_BrotliEncoderSetParameter(s, BROTLI_PARAM_SIZE_HINT,
                min(src_size, Int64(1)<<30)%UInt32
            )
            available_out = Ref(Csize_t(clamped_dst_size))
            result = @ccall libbrotlienc.BrotliEncoderCompressStream(
                s::Ptr{BrotliEncoderState}, # state
                BROTLI_OPERATION_FINISH::Cint, # op
                Ref(Csize_t(src_size))::Ref{Csize_t}, # available_in
                Ref(src_p)::Ref{Ptr{UInt8}}, # next_in
                available_out::Ref{Csize_t}, # available_out
                Ref(dst_p)::Ref{Ptr{UInt8}}, # next_out
                C_NULL::Ptr{Csize_t}, # total_out
            )::Cint
            if result == 1
                is_finished = @ccall libbrotlienc.BrotliEncoderIsFinished(
                    s::Ptr{BrotliEncoderState}, # state
                )::Cint
                if is_finished == 1
                    @assert available_out[] < clamped_dst_size
                    return clamped_dst_size - Int64(available_out[])
                else
                    @assert iszero(available_out[])
                    # not enough output space, try the fallback if it is safe
                    # This is needed because some options may fail to compress
                    # even if given encode_bound output space.
                    if dst_size ≥ max_out_size
                        return unsafe_MakeUncompressedStream(src_p, src_size, dst_p)
                    else
                        return NOT_SIZE
                    end
                end
            else
                throw(OutOfMemoryError())
            end
        finally
            @ccall libbrotlienc.BrotliEncoderDestroyInstance(
                s::Ptr{BrotliEncoderState},
            )::Cvoid
        end
    end
end

"""
    BrotliDecodingError(msg)

Error for data that cannot be decoded.
"""
struct BrotliDecodingError <: DecodingError
    msg::String
end

function Base.showerror(io::IO, err::BrotliDecodingError)
    print(io, "BrotliDecodingError: ")
    print(io, err.msg)
    nothing
end

"""
    struct BrotliDecodeOptions <: DecodeOptions
    BrotliDecodeOptions(; kwargs...)

brotli decompression using the brotli C library <https://brotli.org/>

This is the brotli (.br) format described in RFC 7932

# Keyword Arguments

- `codec::BrotliCodec=BrotliCodec()`
"""
struct BrotliDecodeOptions <: DecodeOptions
    codec::BrotliCodec
end
function BrotliDecodeOptions(;
        codec::BrotliCodec=BrotliCodec(),
        kwargs...
    )
    BrotliDecodeOptions(codec)
end

# https://github.com/google/brotli/issues/501
is_thread_safe(::BrotliDecodeOptions) = true

function try_find_decoded_size(::BrotliDecodeOptions, src::AbstractVector{UInt8})::Nothing
    nothing
end

function try_decode!(d::BrotliDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    try_resize_decode!(d, dst, src, Int64(length(dst)))
end

function try_resize_decode!(d::BrotliDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}, max_size::Int64; kwargs...)::MaybeSize
    dst_size::Int64 = length(dst)
    src_size::Int64 = length(src)
    src_left::Int64 = src_size
    dst_left::Int64 = dst_size
    check_contiguous(dst)
    check_contiguous(src)
    if isempty(src)
        throw(BrotliDecodingError("unexpected end of stream"))
    end
    s = @ccall libbrotlidec.BrotliDecoderCreateInstance(
        C_NULL::Ptr{Cvoid},
        C_NULL::Ptr{Cvoid},
        C_NULL::Ptr{Cvoid},
    )::Ptr{BrotliDecoderState}
    if s == C_NULL
        throw(OutOfMemoryError())
    end
    try
        cconv_src = Base.cconvert(Ptr{UInt8}, src)
        while true
            # dst may get resized, so cconvert needs to be redone on each iteration.
            cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
            GC.@preserve cconv_src cconv_dst begin
                src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
                dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
                available_in = Ref(Csize_t(src_left))
                next_in = src_p + (src_size - src_left)
                available_out = Ref(Csize_t(dst_left))
                next_out = dst_p + (dst_size - dst_left)
                result = @ccall libbrotlidec.BrotliDecoderDecompressStream(
                    s::Ptr{BrotliDecoderState}, # state
                    available_in::Ref{Csize_t}, # available_in
                    next_in::Ref{Ptr{UInt8}}, # next_in
                    available_out::Ref{Csize_t}, # available_out
                    next_out::Ref{Ptr{UInt8}}, # next_out
                    C_NULL::Ptr{Csize_t}, # total_out
                )::Cint
                if result == BROTLI_DECODER_RESULT_SUCCESS || result == BROTLI_DECODER_RESULT_NEEDS_MORE_OUTPUT
                    @assert available_in[] ≤ src_left
                    @assert available_out[] ≤ dst_left
                    src_left = available_in[]
                    dst_left = available_out[]
                    @assert src_left ∈ 0:src_size
                    @assert dst_left ∈ 0:dst_size
                end
                if result == BROTLI_DECODER_RESULT_NEEDS_MORE_OUTPUT
                    @assert iszero(dst_left)
                    local next_size = grow_dst!(dst, max_size)
                    if isnothing(next_size)
                        return NOT_SIZE
                    end
                    dst_left += next_size - dst_size
                    dst_size = next_size
                    @assert dst_left > 0
                elseif result == BROTLI_DECODER_RESULT_SUCCESS
                    if iszero(src_left)
                        # yay done return decompressed size
                        real_dst_size = dst_size - dst_left
                        @assert real_dst_size ∈ 0:length(dst)
                        return real_dst_size
                    else
                        # Otherwise, throw an error
                        throw(BrotliDecodingError("unexpected $(src_left) bytes after stream"))
                    end
                elseif result == BROTLI_DECODER_RESULT_NEEDS_MORE_INPUT
                    throw(BrotliDecodingError("unexpected end of stream"))
                elseif result == BROTLI_DECODER_RESULT_ERROR
                    err_code = @ccall libbrotlidec.BrotliDecoderGetErrorCode(
                        s::Ptr{BrotliDecoderState}, # state
                    )::Cint
                    if err_code ∈ RANGE_BROTLI_DECODER_ERROR_ALLOC
                        throw(OutOfMemoryError())
                    else
                        err_str = @ccall libbrotlidec.BrotliDecoderErrorString(
                            err_code::Cint,
                        )::Ptr{Cchar}
                        throw(BrotliDecodingError(unsafe_string(err_str)))
                    end
                else
                    error("unknown brotli decoder result: $(result)")
                end
            end
        end
        @assert false "unreachable"
    finally
        @ccall libbrotlidec.BrotliDecoderDestroyInstance(
            s::Ptr{BrotliDecoderState},
        )::Cvoid
    end
end
